<?php

/*
 *
 * Make sure to request your API-key first at: 
 *    https://console.developers.google.com
 *
 * Go to the APIs & auth -> APIs and select "Analytics API"
 * Go to the APIs & auth -> Credentials -> Create new Client ID, select "web Application" and enter your scripts URL (can be "localhost") in the "Authorized redirect URIs" box.
 *
 */
  
// From the APIs console
$client_id = '<REPLACE ME>';

// From the APIs console
$client_secret = '<REPLACE ME>';

 // Url to your this page, must match the one in the APIs console
$redirect_uri = '<REPLACE ME>';

// Analytics account id like, 'ga:xxxxxxx'
$account_id = '';

session_start();
include('GoogleAnalyticsAPI.class.php');
header('Content-Type: text/plain');

$ga = new GoogleAnalyticsAPI(); 
$ga->auth->setClientId($client_id);
$ga->auth->setClientSecret($client_secret);
$ga->auth->setRedirectUri($redirect_uri);

if (isset($_GET['force_oauth'])) {
    $_SESSION['oauth_access_token'] = null;
}


/*
 *  Step 1: Check if we have an oAuth access token in our session
 *          If we've got $_GET['code'], move to the next step
 */
if (!isset($_SESSION['oauth_access_token']) && !isset($_GET['code'])) {
    // Go get the url of the authentication page, redirect the client and go get that token!
    $url = $ga->auth->buildAuthUrl();
    header("Location: ".$url);
} 

/*
 *  Step 2: Returning from the Google oAuth page, the access token should be in $_GET['code']
 */
if (!isset($_SESSION['oauth_access_token']) && isset($_GET['code'])) {
    $auth = $ga->auth->getAccessToken($_GET['code']);
    if ($auth['http_code'] == 200) {
        $accessToken    = $auth['access_token'];
        $refreshToken   = $auth['refresh_token'];
        $tokenExpires   = $auth['expires_in'];
        $tokenCreated   = time();
        
        // For simplicity of the example we only store the accessToken
        // If it expires use the refreshToken to get a fresh one
        $_SESSION['oauth_access_token'] = $accessToken;
    } else {
        die("Sorry, something wend wrong retrieving the oAuth tokens");
    }
}

/*
 *  Step 3: Find your account Id
 *          If we're here, we sure we've got an access token
 */
$ga->setAccessToken($_SESSION['oauth_access_token']);
if ($account_id) {
  $ga->setAccountId($account_id);
} else {
  $profiles = $ga->getProfiles();
  $accounts = array();
  foreach ($profiles['items'] as $item) {
      $id = "ga:{$item['id']}";
      $name = $item['name'];
      $accounts[$id] = $name;
  }
  // Print out the Accounts with Id => Name. Save the Id (array-key) of the account you want to query data. 
  // See next chapter how to set the account-id.
  echo "Find your account id and set it as \$account_id in the code!\n";
  print_r($accounts);
  exit;
}


/*
 *  Step 4: Config your metrics
 *          This is where it gets interesting
 */

$enddate = strtotime('last Saturday');  // alternatively use strtotime('2015-04-12') for example
$startdate = strtotime('-6 days -13 weeks', $enddate);
$metric = 'ga:pageviews'; // alternatively use 'ga:visits'

$filters = array();
$filters['Firefox'] = 'ga:browser=@Firefox';
$filters['Safari'] = 'ga:browser=@Safari';


/*
 *  Config ends here
 *  
 */

// Set the default params. For example the start/end dates and max-results
$defaults = array(
    'start-date' => date('Y-m-d', $startdate),
    'end-date'   => date('Y-m-d', $enddate),
);
//print_r($defaults);
$ga->setDefaultQueryParams($defaults);


$data = array();
foreach ($filters as $filter) {
  $params = array(
      'metrics'    => $metric,
      'dimensions' => 'ga:week',
      'filters' => $filter,
  );
  $query = $ga->query($params);

  foreach ($query['rows'] as $row) {
    $data[$row[0]][$filter] = (int)$row[1];
  }
}

print_csv_header($filters);

foreach ($data as $week => $row) {
  echo $week . ';' . implode(';', $row) . "\n";
}

function print_csv_header($filters) {
	echo 'week;';
	foreach ($filters as $key => $filter) {
		if (!is_numeric($key)) echo $key . ';'; else echo $filter . ';';
	}
	echo "\n";
}

